// MediaViewer.h: CMediaViewer NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#pragma once


#include "MediaDecoder.h"
#include "TsUtilClass.h"
#include "BonSrcFilter.h"
#include "AacDecFilter.h"
#include "Mpeg2SequenceFilter.h"
#include "PcmSelectFilter.h"
#include <Bdaiface.h>
#include "DirectShowUtil.h"

// Append by HDUSTest̒̐l
#include "VideoRenderer.h"
#include "../ImageMixer.h"
#include "../Tracer.h"


/////////////////////////////////////////////////////////////////////////////
// fBAr[A(fyщĐ)
/////////////////////////////////////////////////////////////////////////////
// Input	#0	: CTsPacket		̓f[^
/////////////////////////////////////////////////////////////////////////////

class CMediaViewer : public CMediaDecoder
{
public:
	CMediaViewer(IEventHandler *pEventHandler = NULL);
	virtual ~CMediaViewer();

// IMediaDecoder
	virtual void Reset(void);
	virtual const bool InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex = 0UL);

// CMediaViewer
	const bool OpenViewer(HWND hOwnerHwnd = NULL,HWND hMessageDrainHwnd = NULL,
		CVideoRenderer::RendererType RendererType = CVideoRenderer::RENDERER_DEFAULT,
		LPCWSTR pszMpeg2Decoder = NULL);
	void CloseViewer(void);

	const bool Play(void);
	const bool Stop(void);

	const bool SetVideoPID(const WORD wPID);
	const bool SetAudioPID(const WORD wPID);

	// Append by Meru
	const bool ResizeVideoWindow();
	const bool SetViewSize(const int x,const int y);
	const bool SetVolume(const float fVolume);
	const bool GetVideoSize(WORD *pwWidth,WORD *pwHeight) const;
	const bool GetVideoAspectRatio(BYTE *pbyAspectRatioX,BYTE *pbyAspectRatioY) const;
	const BYTE GetAudioChannelNum();
	const bool SetStereoMode(const int iMode);
	const bool GetVideoDecorderName(LPWSTR lpName,int iBufLen);
	const bool DisplayVideoDecoderProperty(HWND hWndParent);
	const bool DisplayVideoRandererProperty(HWND hWndParent);

	// Append by HDUSTest̒̐l
	const bool Pause();
	const bool ForceAspectRatio(int AspectX,int AspectY);
	const bool GetEffectiveAspectRatio(BYTE *pAspectX,BYTE *pAspectY);
	enum { PANANDSCAN_HORZ=1, PANANDSCAN_VERT=2 };
	const bool SetPanAndScan(BYTE bFlags);
	const bool GetOriginalVideoSize(WORD *pWidth,WORD *pHeight) const;
	const bool GetDestRect(RECT *pRect);
	const bool GetDestSize(WORD *pWidth,WORD *pHeight);
	const bool GetCroppedVideoSize(WORD *pWidth,WORD *pHeight);
	const bool GetSourceRect(RECT *pRect);
	const void HideCursor(bool bHide);
	const bool GetCurrentImage(BYTE **ppDib);
	bool SetGrabber(bool bGrabber);
	bool GetGrabber() const { return m_pGrabber!=NULL; }
	void *DoCapture(DWORD WaitTime);
	bool SetAudioNormalize(bool bNormalize,float Level=1.0f);
	CVideoRenderer::RendererType GetVideoRendererType() const;
	/*
	const bool SetVMR9(bool bVMR9);
	const bool GetVMR9() const { return m_pVideoRenderer!=NULL; }
	*/
	const bool RepaintVideo(HWND hwnd,HDC hdc);
	const bool DisplayModeChanged();
	const bool DrawText(LPCTSTR pszText,HFONT hfont,COLORREF crColor,
												int Opacity,RECT *pDestRect);
	const bool ClearOSD();
	bool SetTracer(CTracer *pTracer);
	void Trace(LPCTSTR pszOutput, ...);
protected:
	CCriticalLock m_CriticalLock;

	// DirectShowC^tF[X
	bool m_bInit;
	IMediaControl *m_pMediaControl;

	// DirectShowtB^
	IGraphBuilder *m_pFilterGraph;
	IBaseFilter *m_pMp2DemuxFilter;
	IBaseFilter *m_pMpeg2DecFilter;
	// Source
	IBaseFilter *m_pSrcFilter;
	CBonSrcFilter *m_pBonSrcFilterClass;
	// Mpeg2-Sequence
	IBaseFilter *m_pMpeg2SeqFilter;
	CMpeg2SequenceFilter *m_pMpeg2SeqClass;
	// AAC
	IBaseFilter *m_pAacDecFilter;
	CAacDecFilter *m_pAacDecClass;
	// Pcm Select
	IBaseFilter *m_pPcmSelFilter;
	CPcmSelectFilter *m_pPcmSelClass;
	// Renderer
	CVideoRenderer *m_pVideoRenderer;

	CStringW m_strMpeg2DecorderName;

	// MPEG2DemultiplexerC^tF[X
	IMpeg2Demultiplexer *m_pMp2DemuxInterface;
	IReferenceClock *m_pMp2DemuxRefClock;

	// rfIPID}bv
	IMPEG2PIDMap *m_pMp2DemuxVideoMap;
	IMPEG2PIDMap *m_pMp2DemuxAudioMap;

	// Elementary StreamPID
	WORD m_wVideoEsPID;
	WORD m_wAudioEsPID;

	static void CALLBACK OnMpeg2VideoInfo(const Mpeg2VideoInfo *pVideoInfo,const LPVOID pParam);
	WORD m_wVideoWindowX;
	WORD m_wVideoWindowY;
	Mpeg2VideoInfo m_VideoInfo;
	HWND m_hOwnerWnd;

	// Append by HDUSTest̒̐l
	CVideoRenderer::RendererType m_VideoRendererType;
	int m_ForceAspectX,m_ForceAspectY;
	BYTE m_PanAndScan;
	CImageMixer *m_pImageMixer;
	bool m_bGrabber;
	class CGrabber *m_pGrabber;
	CTracer *m_pTracer;
	const bool CalcSourcePosition(long *pLeft,long *pTop,long *pWidth,long *pHeight) const;

private:
	HRESULT AddToRot(IUnknown *pUnkGraph, DWORD *pdwRegister) const;
	void RemoveFromRot(const DWORD pdwRegister) const;

	DWORD m_dwRegister;
};
