#ifndef CAPTURE_H
#define CAPTURE_H


#include "BasicWindow.h"


class CCapturePreview;

class CCapturePreviewEvent {
protected:
	CCapturePreview *m_pCapturePreview;
public:
	CCapturePreviewEvent();
	virtual ~CCapturePreviewEvent() {}
	virtual bool OnClose() { return true; }
	friend CCapturePreview;
};

class CCapturePreview : public CBasicWindow {
	static HINSTANCE m_hinst;
	HGLOBAL m_hData;
	COLORREF m_crBackColor;
	CCapturePreviewEvent *m_pEvent;
	static CCapturePreview *GetThis(HWND hwnd);
	static LRESULT CALLBACK WndProc(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam);
	void SetTitle();
public:
	static bool Initialize(HINSTANCE hinst);
	CCapturePreview();
	~CCapturePreview();
	bool Create(HWND hwndParent,DWORD Style,DWORD ExStyle=0,int ID=0);
	bool SetImage(const BITMAPINFO *pbmi,const void *pBits);
	bool SetImage(HGLOBAL hData);
	bool ClearImage();
	bool HasImage() const;
	bool SetEventHandler(CCapturePreviewEvent *pEvent);
};


#endif
