#include "stdafx.h"
#include "HDUSTest.h"
#include "EpgProgramList.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif




CServiceInfoData::CServiceInfoData()
{
	m_pszServiceName=NULL;
}


CServiceInfoData::CServiceInfoData(const CServiceInfoData &Info)
{
	*this=Info;
}


CServiceInfoData::CServiceInfoData(WORD OriginalNID,WORD TSID,WORD ServiceID,WORD ServiceType,LPCWSTR pszServiceName)
{
	m_OriginalNID=OriginalNID;
	m_TSID=TSID;
	m_ServiceID=ServiceID;
	m_ServiceType=ServiceType;
	m_pszServiceName=DuplicateString(pszServiceName);
}


CServiceInfoData::~CServiceInfoData()
{
	delete [] m_pszServiceName;
}


CServiceInfoData &CServiceInfoData::operator=(const CServiceInfoData &Info)
{
	m_OriginalNID=Info.m_OriginalNID;
	m_TSID=Info.m_TSID;
	m_ServiceID=Info.m_ServiceID;
	m_ServiceType=Info.m_ServiceType;
	m_pszServiceName=DuplicateString(Info.m_pszServiceName);
	return *this;
}


bool CServiceInfoData::SetServiceName(LPCWSTR pszName)
{
	delete [] m_pszServiceName;
	m_pszServiceName=DuplicateString(pszName);
	return true;
}




CEventInfoData::CEventInfoData()
{
	m_pszEventName=NULL;
	m_pszEventText=NULL;
	m_pszEventExtText=NULL;
	m_pszComponentTypeText=NULL;
	m_pszAudioComponentTypeText=NULL;
}


CEventInfoData::CEventInfoData(const CEventInfoData &Info)
{
	*this=Info;
}


CEventInfoData::~CEventInfoData()
{
	delete [] m_pszEventName;
	delete [] m_pszEventText;
	delete [] m_pszEventExtText;
	delete [] m_pszComponentTypeText;
	delete [] m_pszAudioComponentTypeText;
}


CEventInfoData &CEventInfoData::operator=(const CEventInfoData &Info)
{
	m_OriginalNID=Info.m_OriginalNID;
	m_TSID=Info.m_TSID;
	m_ServiceID=Info.m_ServiceID;
	m_EventID=Info.m_EventID;
	m_pszEventName=DuplicateString(Info.m_pszEventName);
	m_pszEventText=DuplicateString(Info.m_pszEventText);
	m_pszEventExtText=DuplicateString(Info.m_pszEventExtText);
	m_stStartTime=Info.m_stStartTime;
	m_DurationSec=Info.m_DurationSec;
	m_ComponentType=Info.m_ComponentType;
	m_pszComponentTypeText=DuplicateString(Info.m_pszComponentTypeText);
	m_AudioComponentType=Info.m_AudioComponentType;
	m_ESMultiLangFlag=Info.m_ESMultiLangFlag;
	m_MainComponentFlag=Info.m_MainComponentFlag;
	m_SamplingRate=Info.m_SamplingRate;
	m_pszAudioComponentTypeText=DuplicateString(Info.m_pszAudioComponentTypeText);
	m_NibbleList=Info.m_NibbleList;
	return *this;
}


bool CEventInfoData::SetEventName(LPCWSTR pszEventName)
{
	delete [] m_pszEventName;
	m_pszEventName=DuplicateString(pszEventName);
	return true;
}


bool CEventInfoData::SetEventText(LPCWSTR pszEventText)
{
	delete [] m_pszEventText;
	m_pszEventText=DuplicateString(pszEventText);
	return true;
}


bool CEventInfoData::SetEventExtText(LPCWSTR pszEventExtText)
{
	delete [] m_pszEventExtText;
	m_pszEventExtText=DuplicateString(pszEventExtText);
	return true;
}


bool CEventInfoData::SetComponentTypeText(LPCWSTR pszText)
{
	delete [] m_pszComponentTypeText;
	m_pszComponentTypeText=DuplicateString(pszText);
	return true;
}


bool CEventInfoData::SetAudioComponentTypeText(LPCWSTR pszText)
{
	delete [] m_pszAudioComponentTypeText;
	m_pszAudioComponentTypeText=DuplicateString(pszText);
	return true;
}




CEpgProgramList::CEpgProgramList()
{
	m_pEpgDll=NULL;
}


CEpgProgramList::~CEpgProgramList()
{
}


bool CEpgProgramList::UpdateProgramList()
{
	if (m_pEpgDll==NULL)
		return false;

	SERVICE_INFO *pService=NULL;
	DWORD dwServiceCount=0;

	Clear();
	if (!m_pEpgDll->GetServiceListDB(&pService,&dwServiceCount))
		return false;
	for (DWORD i=0;i<dwServiceCount;i++ ) {
		if (pService[i].dwServiceType!=0x01 && pService[i].dwServiceType!=0xA5)
			continue;

		CServiceInfoData Item((WORD)pService[i].dwOriginalNID,
							  (WORD)pService[i].dwTSID,
							  (WORD)pService[i].dwServiceID,
							  (WORD)pService[i].dwServiceType,
							  pService[i].lpwszServiceName);

		ULONGLONG Key=((ULONGLONG)Item.m_OriginalNID<<32) | ((ULONGLONG)Item.m_TSID<<16) | (ULONGLONG)Item.m_ServiceID;

		ServiceMap.insert(std::pair<ULONGLONG,CServiceInfoData>(Key,Item));

		EPG_DATA_INFO2* pEpgData=NULL;
		DWORD dwEpgDataCount=0;
		if (m_pEpgDll->GetEpgDataListDB(Item.m_OriginalNID,Item.m_TSID,Item.m_ServiceID,&pEpgData,&dwEpgDataCount)) {
			CEventInfoList Item2;
			EventMap.insert(std::pair<ULONGLONG,CEventInfoList>(Key,Item2));
			std::map<ULONGLONG,CEventInfoList>::iterator itr;

			itr=EventMap.find(Key);
			if (itr==EventMap.end())
				break;
			for (DWORD j=0;j<dwEpgDataCount;j++) {
				CEventInfoData Item3;

				Item3.m_OriginalNID=(WORD)pEpgData[j].dwOriginalNID;
				Item3.m_TSID=(WORD)pEpgData[j].dwTSID;
				Item3.m_ServiceID=(WORD)pEpgData[j].dwServiceID;
				Item3.m_EventID=(WORD)pEpgData[j].dwEventID;
				Item3.SetEventName(pEpgData[j].lpwszEventName);
				Item3.SetEventText(pEpgData[j].lpwszEventText);
				Item3.SetEventExtText(pEpgData[j].lpwszEventExtText);
				Item3.m_stStartTime=pEpgData[j].stStartTime;
				Item3.m_DurationSec=pEpgData[j].dwDurationSec;
				Item3.m_ComponentType=pEpgData[j].ucComponentType;
				Item3.SetComponentTypeText(pEpgData[j].lpwszComponentTypeText);
				Item3.m_AudioComponentType=pEpgData[j].ucAudioComponentType;
				Item3.m_ESMultiLangFlag=pEpgData[j].ucESMultiLangFlag;
				Item3.m_MainComponentFlag=pEpgData[j].ucMainComponentFlag;
				Item3.m_SamplingRate=pEpgData[j].ucSamplingRate;
				Item3.SetAudioComponentTypeText(pEpgData[j].lpwszAudioComponentTypeText);
				for (DWORD k=0;k<pEpgData[j].dwContentNibbleListCount;k++) {
					NibbleData Nibble;

					Nibble.m_ContentNibbleLv1=(BYTE)((pEpgData[j].dwContentNibbleList[k]&0xFF000000)>>24);
					Nibble.m_ContentNibbleLv2=(BYTE)((pEpgData[j].dwContentNibbleList[k]&0x00FF0000)>>16);
					Nibble.m_UserNibbleLv1=(BYTE)((pEpgData[j].dwContentNibbleList[k]&0x0000FF00)>>8);
					Nibble.m_UserNibbleLv2=(BYTE)(pEpgData[j].dwContentNibbleList[k]&0x000000FF);
					Item3.m_NibbleList.push_back(Nibble);
				}
				itr->second.EventDataMap.insert(std::pair<WORD, CEventInfoData>(Item3.m_EventID,Item3));
			}
		}
	}
	return true;
}


void CEpgProgramList::Clear()
{
	ServiceMap.clear();
	EventMap.clear();
	//m_pEpgDll->ClearData();
}


bool CEpgProgramList::GetEventInfo(WORD ServiceID,WORD EventID,CEventInfoData *pInfo)
{
	ServiceIterator itrService;
	EventListIterator itrEventList;
	EventIterator itrEvent;

	for (itrService=ServiceMap.begin();itrService!=ServiceMap.end();itrService++) {
		if (itrService->second.m_ServiceID==ServiceID)
			break;
	}
	if (itrService==ServiceMap.end())
		return false;
	itrEventList=EventMap.find(itrService->first);
	if (itrEventList==EventMap.end())
		return false;
	itrEvent=itrEventList->second.EventDataMap.find(EventID);
	if (itrEvent==itrEventList->second.EventDataMap.end())
		return false;
	*pInfo=itrEvent->second;
	return true;
}
