#ifndef HDUSTEST_RECORD_H
#define HDUSTEST_RECORD_H


#include "Settings.h"


class CRecordOptions {
	TCHAR m_szSaveFolder[MAX_PATH];
	TCHAR m_szFileName[MAX_PATH];
	bool m_fAddTime;
	bool m_fConfirmChannelChange;
	bool m_fConfirmExit;
	static CRecordOptions *GetThis(HWND hDlg);
public:
	CRecordOptions();
	~CRecordOptions();
	bool Read(CSettings *pSettings);
	bool Write(CSettings *pSettings);
	bool GenerateFileName(LPTSTR pszFileName,int MaxLength,SYSTEMTIME *pTime=NULL,LPCTSTR *ppszErrorMessage=NULL) const;
	bool ConfirmChannelChange(HWND hwndOwner);
	bool ConfirmExit(HWND hwndOwner);
	static BOOL CALLBACK DlgProc(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam);
};

class CRecordManager {
public:
	enum FileExistsOperation {
		EXISTS_OVERWRITE,
		EXISTS_CONFIRM,
		EXISTS_SEQUENCIALNUMBER
	};
private:
	TCHAR m_szFileName[MAX_PATH];
	FileExistsOperation m_ExistsOperation;
	bool m_fStopTimeSpec;
	bool m_fStopDateTime;
	unsigned int m_StopTime;
	FILETIME m_ftStopTime;
	unsigned int m_StartTime;
	FILETIME m_ftStartTime;
	bool m_fRecording;
	static BOOL CALLBACK DlgProc(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam);
	static BOOL CALLBACK StopTimeDlgProc(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam);
public:
	CRecordManager();
	~CRecordManager();
	bool SetFileName(LPCTSTR pszFileName);
	LPCTSTR GetFileName() const { return m_szFileName; }
	bool SetFileExistsOperation(FileExistsOperation Operation);
	FileExistsOperation GetFileExistsOperation() const { return m_ExistsOperation; }
	bool SetStopTimeSpec(bool fSpec);
	bool GetStopTimeSpec() const {return m_fStopTimeSpec; }
	bool SetStopTime(unsigned int Time);
	unsigned int GetStopTime() const { return m_StopTime; }
	bool StartRecord();
	void EndRecord();
	bool IsRecording() const { return m_fRecording; }
	unsigned int GetRecordTime() const;
	bool QueryStop() const;
	bool RecordDialog(HWND hwndOwner,HINSTANCE hinst);
	bool DoFileExistsOperation(HWND hwndOwner,LPTSTR pszFileName);
	DWORD CalcStopTime(DWORD StartTime);
	bool ChangeStopTimeDialog(HWND hwndOwner,HINSTANCE hinst);
};


#endif
